'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash.set');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.get');

var _lodash4 = _interopRequireDefault(_lodash3);

var _lodash5 = require('lodash.has');

var _lodash6 = _interopRequireDefault(_lodash5);

var _lodash7 = require('lodash.includes');

var _lodash8 = _interopRequireDefault(_lodash7);

var _lodash9 = require('lodash.without');

var _lodash10 = _interopRequireDefault(_lodash9);

var _lodash11 = require('lodash.isstring');

var _lodash12 = _interopRequireDefault(_lodash11);

var _lodash13 = require('lodash.reduce');

var _lodash14 = _interopRequireDefault(_lodash13);

var _lodash15 = require('lodash.defaultsdeep');

var _lodash16 = _interopRequireDefault(_lodash15);

var _lodash17 = require('lodash.clonedeep');

var _lodash18 = _interopRequireDefault(_lodash17);

var _lodash19 = require('lodash.map');

var _lodash20 = _interopRequireDefault(_lodash19);

var _emptyFunc = require('./utils/emptyFunc');

var _emptyFunc2 = _interopRequireDefault(_emptyFunc);

var _arrayFrom = require('./utils/arrayFrom');

var _arrayFrom2 = _interopRequireDefault(_arrayFrom);

var _pickDeep = require('./utils/pickDeep');

var _pickDeep2 = _interopRequireDefault(_pickDeep);

var _pickOutermost = require('./utils/pickOutermost');

var _pickOutermost2 = _interopRequireDefault(_pickOutermost);

var _mergeTouchedValues = require('./utils/mergeTouchedValues');

var _mergeTouchedValues2 = _interopRequireDefault(_mergeTouchedValues);

var _valuesWithDefaultsAndExemptions = require('./utils/valuesWithDefaultsAndExemptions');

var _valuesWithDefaultsAndExemptions2 = _interopRequireDefault(_valuesWithDefaultsAndExemptions);

var _Wildcard = require('./constants/Wildcard');

var _Wildcard2 = _interopRequireDefault(_Wildcard);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Joi = void 0;

var DEFAULT_STATE = {
  errors: {},
  values: {},
  touchedValues: {},

  validateAllValues: false
};

function includesAllValues(valuePaths) {
  if (Array.isArray(valuePaths)) {
    return (0, _lodash8.default)(valuePaths, _Wildcard2.default);
  } else {
    return valuePaths === _Wildcard2.default;
  }
}

var ReactJoiValidation = function ReactJoiValidation(ValidatedComponent, _ref) {
  var joiSchema = _ref.joiSchema,
      joiOptions = _ref.joiOptions,
      validator = _ref.validator,
      only = _ref.only;

  function usingSingularValidationScope() {
    return (0, _lodash12.default)(only);
  }

  function scopedPath(valuePath) {
    if (usingSingularValidationScope() && !includesAllValues(valuePath)) {
      return only + '.' + valuePath;
    } else {
      return valuePath;
    }
  }

  function wrapObject(object) {
    if (usingSingularValidationScope()) {
      return _defineProperty({}, only, object);
    } else {
      return object;
    }
  }

  function unwrapObject(object) {
    if (usingSingularValidationScope()) {
      return object[only];
    } else {
      return object;
    }
  }

  function pickErrors(errors, touchedValues) {
    var listOfTouchedValues = (0, _pickOutermost2.default)(touchedValues);

    return (0, _lodash14.default)(listOfTouchedValues, function (activeErrors, valuePath) {

      if (!valuePath.endsWith(_Wildcard2.default)) {
        (0, _lodash2.default)(activeErrors, valuePath, (0, _lodash4.default)(errors, valuePath));
      }

      return activeErrors;
    }, {});
  }

  var ValidatorComponent = function (_Component) {
    _inherits(ValidatorComponent, _Component);

    function ValidatorComponent(props, context) {
      _classCallCheck(this, ValidatorComponent);

      var _this = _possibleConstructorReturn(this, (ValidatorComponent.__proto__ || Object.getPrototypeOf(ValidatorComponent)).call(this, props, context));

      _this.changeHandler = _this.changeHandler.bind(_this);
      _this.handleChange = _this.handleChange.bind(_this);

      _this.validateHandler = _this.validateHandler.bind(_this);
      _this.validate = _this.validate.bind(_this);

      _this.validateAll = _this.validateAll.bind(_this);
      _this.validateAllHandler = _this.validateAllHandler.bind(_this);

      _this.clear = _this.clear.bind(_this);

      _this.state = _extends({}, DEFAULT_STATE);
      return _this;
    }

    _createClass(ValidatorComponent, [{
      key: 'render',
      value: function render() {
        return _react2.default.createElement(ValidatedComponent, _extends({}, this.props, this._valuesWithDefaults(), {

          errors: this._getActiveErrors(),

          changeHandler: this.changeHandler,
          changeValue: this.handleChange,

          validateHandler: this.validateHandler,
          validate: this.validate,

          validateAllHandler: this.validateAllHandler,
          validateAll: this.validateAll,

          clearValidationState: this.clear
        }));
      }
    }, {
      key: '_getActiveErrors',
      value: function _getActiveErrors() {
        var _state = this.state,
            errors = _state.errors,
            validateAllValues = _state.validateAllValues,
            touchedValues = _state.touchedValues;


        var activeErrors = function () {
          if (validateAllValues) {
            return errors;
          } else {
            return pickErrors(errors, touchedValues);
          }
        }();

        return unwrapObject(activeErrors) || {};
      }
    }, {
      key: 'clear',
      value: function clear() {
        this.setState(_extends({}, DEFAULT_STATE));
      }
    }, {
      key: '_valuesWithDefaults',
      value: function _valuesWithDefaults() {
        var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            scope = _ref3.scope;

        var touchedValues = this.state.touchedValues;


        if (only) {
          var validateableFields = (0, _arrayFrom2.default)(only);

          var propValues = (0, _pickDeep2.default)(this.props, validateableFields);

          var defaultValues = (0, _pickDeep2.default)(ValidatedComponent.defaultProps, validateableFields);

          var exemptions = (0, _pickDeep2.default)(touchedValues, validateableFields);

          var propsWithDefaults = (0, _lodash16.default)({}, propValues, defaultValues);

          var values = (0, _valuesWithDefaultsAndExemptions2.default)({
            defaultValue: propsWithDefaults,
            overrides: this.state.values,
            deepMergeExemptions: exemptions
          });

          if (scope) {
            return unwrapObject(values);
          } else {
            return values;
          }
        } else {
          var _propsWithDefaults = (0, _lodash16.default)({}, this.props, ValidatedComponent.defaultProps);

          return (0, _valuesWithDefaultsAndExemptions2.default)({
            defaultValue: _propsWithDefaults,
            overrides: this.state.values,
            deepMergeExemptions: touchedValues
          });
        }
      }
    }, {
      key: 'changeHandler',
      value: function changeHandler(valuePath) {
        var _this2 = this;

        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        return function (event, value) {
          var valueToUse = (0, _lodash6.default)(options, 'value') ? options.value : value;
          _this2.handleChange(valuePath, valueToUse, options);
        };
      }
    }, {
      key: 'handleChange',
      value: function handleChange(valuePath, value) {
        var _this3 = this;

        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
        var _state2 = this.state,
            values = _state2.values,
            touchedValues = _state2.touchedValues;


        var newValues = (0, _lodash18.default)(values);

        (0, _lodash2.default)(newValues, scopedPath(valuePath), value);

        this.setState({
          values: newValues,
          touchedValues: (0, _mergeTouchedValues2.default)([scopedPath(valuePath)], touchedValues)
        }, function () {
          if (options.validate) {
            _this3.validate(options.validate === true ? valuePath : options.validate);
          }
        });
      }
    }, {
      key: 'validateAllHandler',
      value: function validateAllHandler() {
        var _this4 = this;

        var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _emptyFunc2.default;


        return function () {
          _this4.validateAll(callback);
        };
      }
    }, {
      key: 'validateAll',
      value: function validateAll(callback) {
        this.validate(_Wildcard2.default, callback);
      }
    }, {
      key: 'validateHandler',
      value: function validateHandler(valuePaths) {
        var _this5 = this;

        var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : (0, _emptyFunc2.default)();


        return function () {
          _this5.validate(valuePaths, callback);
        };
      }
    }, {
      key: 'validate',
      value: function validate(valuePaths) {
        var _this6 = this;

        var afterValidationCallback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _emptyFunc2.default;

        var valuePathsAsList = (0, _arrayFrom2.default)(valuePaths);
        var afterValidationHandler = this._afterValidationHandler(valuePathsAsList, afterValidationCallback);

        var valuesToValidate = this._valuesWithDefaults({ scope: true });

        if (joiSchema) {
          Joi.validate(valuesToValidate, joiSchema, _extends({ abortEarly: false }, joiOptions), function (joiError) {
            var joiErrorList = joiError && joiError.details || [];

            var errorObject = (0, _lodash14.default)(joiErrorList, function (errors, _ref4) {
              var message = _ref4.message,
                  path = _ref4.path;

              var messageWithFieldNameRemoved = message.replace(/^\".+\" /, '');

              (0, _lodash2.default)(errors, path, messageWithFieldNameRemoved);

              return errors;
            }, {});

            _this6._callValidatorIfDefined(valuePathsAsList, valuesToValidate, errorObject, afterValidationHandler);
          });
        } else {

          this._callValidatorIfDefined(valuePathsAsList, valuesToValidate, {}, afterValidationHandler);
        }
      }
    }, {
      key: '_callValidatorIfDefined',
      value: function _callValidatorIfDefined(valuePaths, values, errors, afterValidatorHasRun) {

        if (validator) {
          validator({
            valuePaths: (0, _lodash10.default)(valuePaths, _Wildcard2.default),
            validateAll: includesAllValues(valuePaths),
            values: values, errors: errors
          }, afterValidatorHasRun);
        } else {
          afterValidatorHasRun({ values: values, errors: errors });
        }
      }
    }, {
      key: '_afterValidationHandler',
      value: function _afterValidationHandler(valuePaths, afterValidationComplete) {
        var _this7 = this;

        return function (_ref5) {
          var values = _ref5.values,
              errors = _ref5.errors;
          var _state3 = _this7.state,
              validateAllValues = _state3.validateAllValues,
              touchedValues = _state3.touchedValues;


          var scopedValuePaths = (0, _lodash20.default)(valuePaths, function (valuePath) {
            return scopedPath(valuePath);
          });

          var newState = {
            values: wrapObject(values),
            errors: wrapObject(errors),
            touchedValues: (0, _mergeTouchedValues2.default)(scopedValuePaths, touchedValues),
            validateAllValues: validateAllValues || includesAllValues(valuePaths)
          };

          _this7.setState(newState, afterValidationComplete);
        };
      }
    }]);

    return ValidatorComponent;
  }(_react.Component);

  ValidatorComponent.propTypes = {
    onSubmit: _react.PropTypes.func,
    errors: _react.PropTypes.object,
    onChange: _react.PropTypes.func
  };

  return ValidatorComponent;
};

ReactJoiValidation.setJoi = function (joiClass) {
  Joi = joiClass;
};

exports.default = ReactJoiValidation;